<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfWSEntryException ArrayType
 * @subpackage Arrays
 */
class ArrayOfWSEntryException extends AbstractStructArrayBase
{
    /**
     * The WSEntryException
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\WSEntryException[]
     */
    public $WSEntryException;
    /**
     * Constructor method for ArrayOfWSEntryException
     * @uses ArrayOfWSEntryException::setWSEntryException()
     * @param \StructType\WSEntryException[] $wSEntryException
     */
    public function __construct(array $wSEntryException = array())
    {
        $this
            ->setWSEntryException($wSEntryException);
    }
    /**
     * Get WSEntryException value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\WSEntryException[]|null
     */
    public function getWSEntryException()
    {
        return isset($this->WSEntryException) ? $this->WSEntryException : null;
    }
    /**
     * This method is responsible for validating the values passed to the setWSEntryException method
     * This method is willingly generated in order to preserve the one-line inline validation within the setWSEntryException method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateWSEntryExceptionForArrayConstraintsFromSetWSEntryException(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfWSEntryExceptionWSEntryExceptionItem) {
            // validation for constraint: itemType
            if (!$arrayOfWSEntryExceptionWSEntryExceptionItem instanceof \StructType\WSEntryException) {
                $invalidValues[] = is_object($arrayOfWSEntryExceptionWSEntryExceptionItem) ? get_class($arrayOfWSEntryExceptionWSEntryExceptionItem) : sprintf('%s(%s)', gettype($arrayOfWSEntryExceptionWSEntryExceptionItem), var_export($arrayOfWSEntryExceptionWSEntryExceptionItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The WSEntryException property can only contain items of type \StructType\WSEntryException, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set WSEntryException value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\WSEntryException[] $wSEntryException
     * @return \ArrayType\ArrayOfWSEntryException
     */
    public function setWSEntryException(array $wSEntryException = array())
    {
        // validation for constraint: array
        if ('' !== ($wSEntryExceptionArrayErrorMessage = self::validateWSEntryExceptionForArrayConstraintsFromSetWSEntryException($wSEntryException))) {
            throw new \InvalidArgumentException($wSEntryExceptionArrayErrorMessage, __LINE__);
        }
        if (is_null($wSEntryException) || (is_array($wSEntryException) && empty($wSEntryException))) {
            unset($this->WSEntryException);
        } else {
            $this->WSEntryException = $wSEntryException;
        }
        return $this;
    }
    /**
     * Add item to WSEntryException value
     * @throws \InvalidArgumentException
     * @param \StructType\WSEntryException $item
     * @return \ArrayType\ArrayOfWSEntryException
     */
    public function addToWSEntryException(\StructType\WSEntryException $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\WSEntryException) {
            throw new \InvalidArgumentException(sprintf('The WSEntryException property can only contain items of type \StructType\WSEntryException, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->WSEntryException[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\WSEntryException|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\WSEntryException|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\WSEntryException|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\WSEntryException|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\WSEntryException|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string WSEntryException
     */
    public function getAttributeName()
    {
        return 'WSEntryException';
    }
}
