<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfWSTaskRecipient ArrayType
 * @subpackage Arrays
 */
class ArrayOfWSTaskRecipient extends AbstractStructArrayBase
{
    /**
     * The WSTaskRecipient
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\WSTaskRecipient[]
     */
    public $WSTaskRecipient;
    /**
     * Constructor method for ArrayOfWSTaskRecipient
     * @uses ArrayOfWSTaskRecipient::setWSTaskRecipient()
     * @param \StructType\WSTaskRecipient[] $wSTaskRecipient
     */
    public function __construct(array $wSTaskRecipient = array())
    {
        $this
            ->setWSTaskRecipient($wSTaskRecipient);
    }
    /**
     * Get WSTaskRecipient value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\WSTaskRecipient[]|null
     */
    public function getWSTaskRecipient()
    {
        return isset($this->WSTaskRecipient) ? $this->WSTaskRecipient : null;
    }
    /**
     * This method is responsible for validating the values passed to the setWSTaskRecipient method
     * This method is willingly generated in order to preserve the one-line inline validation within the setWSTaskRecipient method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateWSTaskRecipientForArrayConstraintsFromSetWSTaskRecipient(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfWSTaskRecipientWSTaskRecipientItem) {
            // validation for constraint: itemType
            if (!$arrayOfWSTaskRecipientWSTaskRecipientItem instanceof \StructType\WSTaskRecipient) {
                $invalidValues[] = is_object($arrayOfWSTaskRecipientWSTaskRecipientItem) ? get_class($arrayOfWSTaskRecipientWSTaskRecipientItem) : sprintf('%s(%s)', gettype($arrayOfWSTaskRecipientWSTaskRecipientItem), var_export($arrayOfWSTaskRecipientWSTaskRecipientItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The WSTaskRecipient property can only contain items of type \StructType\WSTaskRecipient, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set WSTaskRecipient value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\WSTaskRecipient[] $wSTaskRecipient
     * @return \ArrayType\ArrayOfWSTaskRecipient
     */
    public function setWSTaskRecipient(array $wSTaskRecipient = array())
    {
        // validation for constraint: array
        if ('' !== ($wSTaskRecipientArrayErrorMessage = self::validateWSTaskRecipientForArrayConstraintsFromSetWSTaskRecipient($wSTaskRecipient))) {
            throw new \InvalidArgumentException($wSTaskRecipientArrayErrorMessage, __LINE__);
        }
        if (is_null($wSTaskRecipient) || (is_array($wSTaskRecipient) && empty($wSTaskRecipient))) {
            unset($this->WSTaskRecipient);
        } else {
            $this->WSTaskRecipient = $wSTaskRecipient;
        }
        return $this;
    }
    /**
     * Add item to WSTaskRecipient value
     * @throws \InvalidArgumentException
     * @param \StructType\WSTaskRecipient $item
     * @return \ArrayType\ArrayOfWSTaskRecipient
     */
    public function addToWSTaskRecipient(\StructType\WSTaskRecipient $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\WSTaskRecipient) {
            throw new \InvalidArgumentException(sprintf('The WSTaskRecipient property can only contain items of type \StructType\WSTaskRecipient, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->WSTaskRecipient[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\WSTaskRecipient|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\WSTaskRecipient|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\WSTaskRecipient|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\WSTaskRecipient|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\WSTaskRecipient|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string WSTaskRecipient
     */
    public function getAttributeName()
    {
        return 'WSTaskRecipient';
    }
}
